package io.xjar;

import java.io.OutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.io.File;
import io.xjar.key.XKey;

public abstract class XWrappedDecryptor implements XDecryptor
{
    protected final XDecryptor xDecryptor;
    
    protected XWrappedDecryptor(final XDecryptor xDecryptor) {
        this.xDecryptor = xDecryptor;
    }
    
    @Override
    public void decrypt(final XKey key, final File src, final File dest) throws IOException {
        this.xDecryptor.decrypt(key, src, dest);
    }
    
    @Override
    public void decrypt(final XKey key, final InputStream in, final OutputStream out) throws IOException {
        this.xDecryptor.decrypt(key, in, out);
    }
    
    @Override
    public InputStream decrypt(final XKey key, final InputStream in) throws IOException {
        return this.xDecryptor.decrypt(key, in);
    }
    
    @Override
    public OutputStream decrypt(final XKey key, final OutputStream out) throws IOException {
        return this.xDecryptor.decrypt(key, out);
    }
}
